const uri = /[a-z][a-z0-9+-.]*:((\/\/(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:]|%[a-f0-9]{2})*@)?((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-\._~!$&'\(\)\/\*\+,;=]|%[a-f0-9]{2})+(:[0-9]+)?(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*)|(\/(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]+|%[a-f0-9]{2})(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*)?)|(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]+|%[a-f0-9]{2})(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*))+(\?([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@/?]|%[a-f0-9]{2})*)?/i;
const illegal = /^(a|button|label|legend|option|script|select|style|textarea|title)$/i;

function main()
{
	var expression = ".//text()";
	var elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements == null) return;
	for (var i = 0; i < elements.snapshotLength; i++) textToLink(elements.snapshotItem(i));
}

function textToLink(element)
{
	if (element.parentNode.tagName.match(illegal)) return;
	var matches = element.nodeValue.match(uri);
	if (matches == null) return;
	var text = matches[0];
	var index = element.nodeValue.indexOf(text);
	if (index == 0)
	{
		if (element.nodeValue.length > text.length) textToLink(element.splitText(text.length));
		var link = document.createElement("a");
		link.href = element.nodeValue;
		element.parentNode.insertBefore(link, element);
		link.appendChild(element); // TEXT TO LINK
	}
	else textToLink(element.splitText(index));
}

main();
